// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

//See this http://msdn2.microsoft.com/en-us/library/system.globalization.cultureinfo.aspx

using System;
using System.Resources;
using System.Threading;
using System.Collections;
using System.Globalization;
using System.Text;

using System.Security.Permissions;

[assembly:SecurityPermission( SecurityAction.RequestMinimum, ControlThread = true )]

namespace MonoCalendar.i18n {
	
	public class tr {
		ResourceManager userStrings;
		ResourceManager userStrings2;
//		ResourceManager localStrings;
		Hashtable strings;
		static tr me;

		public tr() {
			me = this;
			strings = new Hashtable();

			string language = Thread.CurrentThread.CurrentUICulture.Name;
			LoadLanguage(language);
//			localStrings = new ResourceManager("StringResources",  this.GetType().Assembly);
		}

		string addHash(string key, string name)
		{
//			name = String.Format("({0})", name);
			strings.Add(key, name);
			return name;
		}

		static public string GetString(string name)
		{
			return me.GetString2(name);
		}

		string GetString2(string name)
		{
			if (strings[name] != null) return strings[name].ToString();

			string aux;
			try {
				aux = userStrings.GetString(name);
				if ((aux != null) && (aux != "")) return addHash(name, aux);
			} catch (Exception) { }
			try {
				aux = userStrings2.GetString(name);
				if ((aux != null) && (aux != "")) return addHash(name, aux);
			} catch (Exception) { }

			return addHash(name, name);
		}

		public static tr Me {
			get {
				return me;
			}
		}
		
		public void LoadLanguage(string language) {
			strings.Clear();
			userStrings = new ResourceManager("StringResources." + language,  this.GetType().Assembly); 
			userStrings2 = new ResourceManager("StringResources." + language.Split('-')[0],  this.GetType().Assembly); 
			try {
				Thread.CurrentThread.CurrentUICulture = new CultureInfo(language, false);
//				Console.WriteLine(Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortDatePattern);
//				Console.WriteLine(Thread.CurrentThread.CurrentUICulture.DateTimeFormat.LongDatePattern);
			} catch (Exception) {
				try {
					Thread.CurrentThread.CurrentUICulture = new CultureInfo(language.Split('-')[0], false);
				} catch (Exception) {}
			}
			try {
				Thread.CurrentThread.CurrentCulture = new CultureInfo(language, false);
			} catch (Exception) {
				try {
					Thread.CurrentThread.CurrentCulture = new CultureInfo(language.Split('-')[0], false);
				} catch (Exception) {}
			}
		}
	}
}
